### PROBLEM LINK:

**Author:** Dmytro Berezin

**Tester:** Sergey Kulik

**Editorialist:** Kevin Atienza

### PREREQUISITES:

Dynamic programming

### PROBLEM:

Chef has an image S consisting of just 10 pixels in a row. Each pixel is either black or white. There are N filters, where each filter is a string of length 10 consisting of `+`

and `-`

characters. If a particular filter is applied, then all pixels corresponding to `+`

s in the filter will get *flipped*.

How many different subsets of the filters will turn the image into an all-black image?

### QUICK EXPLANATION:

We can replace images and filters with binary numbers of at most |S| bits, where â€śwhiteâ€ť and `+`

correspond to 1. In this representation, there are 2^{|S|} distinct filters and 2^{|S|} distinct images, 0 \ldots 2^{|S|}-1, and applying a filter means simply performing a bitwise-XOR with the filter on the image.

Let c_i be the number of filters i present in the input. Define f(i,j) be the number of ways to turn the image j into an all-black image (i.e. image 0) using only the first i+1 distinct kinds of filters. We can compute f(i,j) using dynamic programming. The following is a recurrence for f(i,j):

The answer is simply f(2^{|S|}-1, S). (where |S| is not the absolute value, rather it is the length of the original input string. In this problem this value is always 10.)

Since there are around 4^{|S|} \le 1.05\times 10^6 possible arguments to f, we can *tabulate* f(i,j). If the entries of this table is filled in order of increasing i, then weâ€™ll be able to compute all entries in just O(4^{|S|}) time.

### EXPLANATION:

The problem can be stated in terms of binary strings. An â€śimageâ€ť and a â€śfilterâ€ť is really just a binary string of length 10. So letâ€™s say we replace â€śwhiteâ€ť and â€ś`+`

â€ť with 1, and â€śblackâ€ť and â€ś`-`

â€ť with 0. Then:

- The initial image S can be represented as an integer from 0 to 2^{10}-1.
- The all-black image is simply image 0.
- A filter F can be represented as an integer from 0 to 2^{10}-1.
- The result of applying the filter F to S is simply the bitwise XOR of F and S, denoted F\oplus S. This is clear from the problem and from the definition of bitwise XOR. (see the appendix for a refresher on bitwise XOR)

The problem is now:

**Given an integer S and a set of N filters (represented by integers), how many subsets of filters are there such that applying the bitwise-XOR of each filter to S results in image 0?**

Note that filters are considered distinct even if they are represented by the same integer.

# Subsets with bitwise XOR zero

N can be very large, especially in the last subtask, so this seems intractable. However, notice that while N can reach up to 10^5, the number of *distinct* filters is at most 2^{10}. This suggests grouping the filters according to the integer representing them. This reordering/grouping doesnâ€™t affect the answer, because order doesnâ€™t matter in subsets (and also because bitwise XOR is commutative and associative).

So now, instead of our N filters, we can replace it with a list c_0, c_1, c_2 \ldots c_{2^{10}-1}, where c_i is the number of filters that are represented by the integer i.

Now, what happens if we apply a set of filters represented by the same integer, say, i? After applying the first one, the image becomes S\oplus i. Then after applying the second one, it becomes the value S\oplus i\oplus i. But this is just equal to S! In other words, applying two equivalent filters is the same as applying none at all. Okay, letâ€™s proceed. After applying third one, the number becomes S\oplus i again, which is the same as applying only once! We can continue with this for more and more filters to get the following fact:

*Applying an odd number of equivalent filters is the same as applying just one equivalent filter. Applying an even number of equivalent filters is the same as applying none.*

This makes things much easier. Suppose we look at a particular integer, say i. Then there are only two possible outcomes when applying any number of filters with the integer i to S: S and S\oplus i. Also, applying every even subset of our set of filters results in S, and applying every odd subset results in S\oplus i. Thus, we just need to know how many subsets are odd and even.

Suppose there are c_i filters. How many subsets are there? For each element, there are two choices, whether to include it or not, so there are \underbrace{2\cdot 2\cdots 2}_{c_i} or 2^{c_i} subsets.

How many of those are even? Similarly as above, we can choose, for each element, whether to include it or not. Thus, there are again two choices for each element. However, the last element is special! This is because we want to ensure that the size of the set is even. So in selecting the last element, we first check whether the size of the subset already constructed is even or odd. If it is odd, then we have no choice but to *include* the last element to the set to make it even. If it is even, then we have no choice but to *exclude* the last element, otherwise it will be odd. Therefore, after making the choices for the first c_i - 1 elements, there is a unique choice for the last element. This implies that the number of even-sized subsets is equal to 2^{c_i-1}! A very similar argument shows that there are also 2^{c_i-1} odd-sized subsets.

Note that the argument above only holds for c_i is not 0. But the case c_i = 0 is trivial: there is only one such set, namely the empty set, and it is even.

Armed with this, we can now devise a dynamic programming solution for the problem. Letâ€™s define f(i,j) as the number of ways to turn the image j into image 0 using only the first i+1 distinct kinds of filters. The answer is simply f(2^{10}-1, S).

To compute f(i,j), consider the filters represented by i. There are c_i such filters. There are 2^{c_i-1} even-sized subsets, and when every such set of filters is applied, the resulting image is j. There are 2^{c_i-1} odd-sized subsets, and when every such set of filters is applied, the resulting image is j\oplus i. Therefore, we have the following general recurrence:

(donâ€™t forget to reduce modulo 10^9 + 7!)

Note that this only works when i \ge 0 and c_i > 0. If c_i = 0, then there are no filters i so we can simply say f(i,j) = f(i-1,j). Finally, if i < 0, then there are no filters to apply altogether, and the only way to turn j into zero is if j is already zero! Thus, we have: f(-1,0) = 1 and f(-1,j) = 0 for j \not= 0.

Summarizing these formulas, we now have the following:

(The expression â€ś[j = 0]â€ť uses the Iverson bracket notation.)

Since there are around 4^{10} \le 1.05\times 10^6 possible *distinct* arguments to f, we can *tabulate* f(i,j), and populate this table in increasing order of i. Filling a table of up to 10^6 elements easily passes the time limit, even in Python! (This is an example of dynamic programming.)

# Appendix: bitwise XOR

Itâ€™s helpful to refresh oneself about the bitwise XOR operation. The bitwise XOR of two numbers is obtained by writing two numbers in binary, padding with leading zeroes if necessary so they have the same number of digits, and â€śXORâ€ť-ing each column. The resulting binary number is the bitwise XOR. (Remember that the XOR of two bits is 1 if they are different, and 0 if they are the same.)

For example, the bitwise XOR of 143=10001111_2 and 202=11001010_2 can be obtained as:

Thus, 143\oplus 202=01000101_2=69.

Based on this definition, the bitwise XOR has the following properties (straightforward to prove):

(we invite you to derive these properties yourself)

Notice that addition and multiplication follow similar rules. The XOR-identity element is 0 (just like in addition, while in multiplication it is 1). However, interestingly, the *XOR-inverse of every number is itself*! (whereas in addition, this is only true for 0, and in multiplication this is only true for 1 and -1)

From these properties, we can also prove the following:

We can call this the *cancellation law*.

The forward direction (a = b \Longrightarrow a\oplus c = b\oplus c) is trivial. To prove the backward direction, letâ€™s assume that a\oplus c = b\oplus c. Then:

which is what we wanted to prove.

### Time Complexity:

O(4^{|S|})